YORIK’S COFFEE CORNER

You are currently viewing a single post of this guestblog.

Click here to go back the complete page. I would be glad to hear your comments, so don’t hesitate to leave me your feedback below. It will appear on the main guestblog page.


in categories  opensource  freecad  permalink:  120   posted on 09.08.2010 23:06
From Yorik

What's new on the FreeCAD front



There are several cool new things coming to FreeCAD so I decided to show you a bit of what's going on. Most of this stuff will be in the 0.11 release (no release date prevision, it's done when it's done). There is a 0.11 preview installer for windows on the FreeCAD website, otherwise you'll have to wait a bit (or compile FreeCAD yourself if you are brave enough). I'll focus more on the 2D part, since it's what I'm mostly doing there...

The most interesting thing that has been added recently by Werner is python-driven Part objects. Unlike the older python Document objects, where you had to do everything, compute the geometry, and define how that geometry gets displayed in the 3D scene, the new Part python objects automatically display their geometry the "standard FreeCAD way". That allows for extremely simple python objects such as this:
class Line:
    def __init__(self, obj):
        ''' App two point properties '''
        obj.addProperty("App::PropertyVector","p1","myCategory","Start point")
        obj.addProperty("App::PropertyVector","p2","myCategory","End point").p2=FreeCAD.Vector(1,0,0)
        obj.Proxy = self
 
    def execute(self, obj):
        ''' Print a short message when doing a recomputation, this method is mandatory '''
        obj.Shape = Part.makeLine(obj.p1,obj.p2)
 
ml=FreeCAD.ActiveDocument.addObject("Part::FeaturePython","myLine")
Line(ml)
As a result, the 2D drafting module has been completely upgraded to take advantage of this. One of the most useful consequences is that it now has an editmode. But it also allows for several other goodies, such as enter FreeCAD's parametric chain (for example, an object made of the union of two other objects retains the original objects, etc):



Because of this, the use of the Drawing module is now much easier, and you can already output much better sheets:





Another area that is being currently worked on by Jürgen is the Sketcher, which allows you to draw constrained 2D shapes. There is still not much new stuff visible, but it has been almost rewritten from scratch, and is now much more stable and works on all platforms. Now really the sketcher can be used to build geometry.



Of course all this is pretty new and lots of bugs are expected to appear, but we come everyday closer to the day we can start to do serious productive work with FreeCAD. As a sidenote, one of the things we lack badly is bug reporting. If you happen to find a bug, if you make FreeCAD crash and can reproduce the cause of the crash, don't hesitate and add a report to the bug tracker. This is a very important for FreeCAD to reach some stability...

First and foremost, your name:

And your message:

To publish it, just press this ...